VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsScreens"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'---------------------------------------------------------------------------------------
' Module    : clsScreens
' DateTime  : 30/04/2007 23:22
' Author    : Vb System Library
' Purpose   : Informations sur les crans installs sur l'ordinateur
' Copyright : (C) 2007 L'quipe Vb System Library
'              See "modPresentation" for more information
'---------------------------------------------------------------------------------------
' Librairie de fonctions permettant d'agir simplement et rapidement sur le systme.
' Copyright (C) 2007 - L'quipe Vb System Library
' This library is free software; you can redistribute it and/or
' modify it under the terms of the GNU Lesser General Public
' License as published by the Free Software Foundation; either
' version 2.1 of the License, or (at your option) any later version.
' This library is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
' Lesser General Public License for more details.
' You should have received a copy of the GNU Lesser General Public
' License along with this library; if not, write to the Free Software
' Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
'---------------------------------------------------------------------------------------


Option Explicit

' Les infos sur un cran
Public Type MonitorInfos
    Handle As Long
    Name As String
    Dimensions As RECT
    WorkingArea As RECT
    IsMainMonitor As Boolean
End Type


'---------------------------------------------------------------------------------------
' Procedure : GetMonitor
' DateTime  : 30/04/2007 23:36
' Author    : Vb System Library
' Purpose   : Renvoie un objet Monitor
' Params    : hMonitor : Handle de l'cran
'---------------------------------------------------------------------------------------
Public Function GetMonitor(ByVal hMonitor As Long) As Monitor
    Set GetMonitor = New Monitor
    GetMonitor.GetMonitorByHandle hMonitor
End Function


'---------------------------------------------------------------------------------------
' Procedure : GetVirtualScreen
' DateTime  : 30/04/2007 23:36
' Author    : Vb System Library
' Purpose   : Renvoie un objet VirtualScreen
' Params    :
'---------------------------------------------------------------------------------------
Public Function GetVirtualScreen() As VirtualScreen
    Set GetVirtualScreen = New VirtualScreen
    GetVirtualScreen.RefreshMonitorList
End Function


'---------------------------------------------------------------------------------------
' Procedure : GetMonitorInfos
' DateTime  : 29/04/2007 23:45
' Author    : Vb System Library
' Purpose   : Renvoie les infos du moniteur
' Params    : hMonitor : Handle de l'cran
'---------------------------------------------------------------------------------------
Public Function GetMonitorInfos(ByVal hMonitor As Long) As MonitorInfos

    Dim Mretour As MonitorInfos
    Dim MonInfos As MONITORINFOEXW
    Dim iPos As Long

    Mretour.Handle = hMonitor
    ' Retrouve les infos
    MonInfos.cbSize = Len(MonInfos)
    GetMonitorInfoW hMonitor, MonInfos
    With MonInfos
        Mretour.Dimensions = .rcMonitor
        Mretour.WorkingArea = .rcWork
        Mretour.IsMainMonitor = ((.dwFlags And MONITORINFOF_PRIMARY) = MONITORINFOF_PRIMARY)
        Mretour.Name = .b
    End With

    ' Formate le nom
    iPos = InStr(Mretour.Name, vbNullChar)
    If (iPos > 0) Then
        Mretour.Name = Left$(Mretour.Name, iPos - 1)
    End If
    
    GetMonitorInfos = Mretour

End Function


'---------------------------------------------------------------------------------------
' Procedure : GetVirtualScreenDimensions
' DateTime  : 29/04/2007 22:43
' Author    : Vb System Library
' Purpose   : Renvoie les dimensions de l'cran virtuel
' Params    :
'---------------------------------------------------------------------------------------
Public Function GetVirtualScreenDimensions() As RECT
    With GetVirtualScreenDimensions
        .Left = GetVirtualScreenLeft()
        .Top = GetVirtualScreenTop()
        .Right = .Left + GetVirtualScreenWidth()
        .Bottom = .Top + GetVirtualScreenHeight()
    End With
End Function
Public Function GetVirtualScreenLeft() As Long
    GetVirtualScreenLeft = GetSystemMetrics(SM_XVIRTUALSCREEN)
End Function
Public Function GetVirtualScreenTop() As Long
    GetVirtualScreenTop = GetSystemMetrics(SM_YVIRTUALSCREEN)
End Function
Public Function GetVirtualScreenWidth() As Long
    GetVirtualScreenWidth = GetSystemMetrics(SM_CXVIRTUALSCREEN)
End Function
Public Function GetVirtualScreenHeight() As Long
    GetVirtualScreenHeight = GetSystemMetrics(SM_CYVIRTUALSCREEN)
End Function
