VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsSystem"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'---------------------------------------------------------------------------------------
' Module    : clsSystem
' DateTime  : 30/04/2007 23:26
' Author    : Vb System Library
' Purpose   : Informations et actions gnrales sur le systme
' Copyright : (C) 2007 L'quipe Vb System Library
'              See "modPresentation" for more information
'---------------------------------------------------------------------------------------
' Librairie de fonctions permettant d'agir simplement et rapidement sur le systme.
' Copyright (C) 2007 - L'quipe Vb System Library
' This library is free software; you can redistribute it and/or
' modify it under the terms of the GNU Lesser General Public
' License as published by the Free Software Foundation; either
' version 2.1 of the License, or (at your option) any later version.
' This library is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
' Lesser General Public License for more details.
' You should have received a copy of the GNU Lesser General Public
' License along with this library; if not, write to the Free Software
' Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
'---------------------------------------------------------------------------------------


Option Explicit

' Les constantes pour redmarrer, teindre...
Private Const EWX_LOGOFF = 0
Private Const EWX_SHUTDOWN = 1
Private Const EWX_REBOOT = 2
Private Const EWX_FORCE = 4

' Pour le calcul de l'utilisation du CPU
Private liOldIdleTime As Currency
Private liOldSystemTime As Currency

Public Type GLOBAL_MEMORY_INFO
    UsedPhysicalMemory As Currency
    TotalPhysicalMemory As Currency
    AvailablePhysicalMemory As Currency
    TotalPageFile As Currency
    AvailablePageFile As Currency
    TotalVirtualMemory As Currency
    AvailableVirtualMemory As Currency
End Type

Public Enum SYSTEM_METRICS_CONSTANTS
    SM_CXSCREEN = 0 'X Size of screen
    SM_CYSCREEN = 1 'Y Size of Screen
    SM_CXVSCROLL = 2 'X Size of arrow in vertical scroll bar.
    SM_CYHSCROLL = 3 'Y Size of arrow in horizontal scroll bar
    SM_CYCAPTION = 4 'Height of windows caption
    SM_CXBORDER = 5 'Width of no-sizable borders
    SM_CYBORDER = 6 'Height of non-sizable borders
    SM_CXDLGFRAME = 7 'Width of dialog box borders
    SM_CYDLGFRAME = 8 'Height of dialog box borders
    SM_CYVTHUMB = 9 'Height of scroll box on horizontal scroll bar
    SM_CXHTHUMB = 10 ' Width of scroll box on horizontal scroll bar
    SM_CXICON = 11 'Width of standard icon
    SM_CYICON = 12 'Height of standard icon
    SM_CXCURSOR = 13 'Width of standard cursor
    SM_CYCURSOR = 14 'Height of standard cursor
    SM_CYMENU = 15 'Height of menu
    SM_CXFULLSCREEN = 16 'Width of client area of maximized window
    SM_CYFULLSCREEN = 17 'Height of client area of maximized window
    SM_CYKANJIWINDOW = 18 'Height of Kanji window
    SM_MOUSEPRESENT = 19 'True is a mouse is present
    SM_CYVSCROLL = 20 'Height of arrow in vertical scroll bar
    SM_CXHSCROLL = 21 'Width of arrow in vertical scroll bar
    SM_DEBUG = 22 'True if deugging version of windows is running
    SM_SWAPBUTTON = 23 'True if left and right buttons are swapped.
    SM_CXMIN = 28 'Minimum width of window
    SM_CYMIN = 29 'Minimum height of window
    SM_CXSIZE = 30 'Width of title bar bitmaps
    SM_CYSIZE = 31 'height of title bar bitmaps
    SM_CXMINTRACK = 34 'Minimum tracking width of window
    SM_CYMINTRACK = 35 'Minimum tracking height of window
    SM_CXDOUBLECLK = 36 'double click width
    SM_CYDOUBLECLK = 37 'double click height
    SM_CXICONSPACING = 38 'width between desktop icons
    SM_CYICONSPACING = 39 'height between desktop icons
    SM_MENUDROPALIGNMENT = 40 'Zero if popup menus are aligned to the left of the memu bar item. True if it is aligned to the right.
    SM_PENWINDOWS = 41 'The handle of the pen windows DLL if loaded.
    SM_DBCSENABLED = 42 'True if double byte characteds are enabled
    SM_CMOUSEBUTTONS = 43 'Number of mouse buttons.
    SM_CMETRICS = 44 'Number of system metrics
    SM_CLEANBOOT = 67 'Windows 95 boot mode. 0 = normal, 1 = safe, 2 = safe with network
    SM_CXMAXIMIZED = 61 'default width of win95 maximised window
    SM_CXMAXTRACK = 59 'maximum width when resizing win95 windows
    SM_CXMENUCHECK = 71 'width of menu checkmark bitmap
    SM_CXMENUSIZE = 54 'width of button on menu bar
    SM_CXMINIMIZED = 57 'width of rectangle into which minimised windows must fit.
    SM_CYMAXIMIZED = 62 'default height of win95 maximised window
    SM_CYMAXTRACK = 60 'maximum width when resizing win95 windows
    SM_CYMENUCHECK = 72 'height of menu checkmark bitmap
    SM_CYMENUSIZE = 55 'height of button on menu bar
    SM_CYMINIMIZED = 58 'height of rectangle into which minimised windows must fit.
    SM_CYSMCAPTION = 51 'height of windows 95 small caption
    SM_MIDEASTENABLED = 74 'Hebrw and Arabic enabled for windows 95
    SM_NETWORK = 63 'bit o is set if a network is present. Const SM_SECURE = 44 'True if security is present on windows 95 system
    SM_SLOWMACHINE = 73 'true if machine is too slow to run win95.
    SM_APPBARHEIGHT = 187   'custom value ==> hauteur de la barre des tches
End Enum


'---------------------------------------------------------------------------------------
' Procedure : ShutDown
' DateTime  : 29/08/2007 19h00
' Author    : Vb System Library
' Purpose   : Extinction de l'ordinateur
' Params    : Force : forcer ou non l'action
'---------------------------------------------------------------------------------------
Public Function ShutDown(Optional ByVal Force As Boolean = False)

    'si on est sous NT, on rcupre le privilge
    If IsPrivilegeNecessary Then Call EnableShutDown

    If Force Then
        ShutDown = ExitWindowsEx(EWX_FORCE Or EWX_SHUTDOWN, 0)
    Else
        ShutDown = ExitWindowsEx(EWX_SHUTDOWN, 0)
    End If
End Function


'---------------------------------------------------------------------------------------
' Procedure : Reboot
' DateTime  : 29/08/2007 19h00
' Author    : Vb System Library
' Purpose   : Redmarrage de l'ordinateur
' Params    : Force : forcer ou non l'action
'---------------------------------------------------------------------------------------
Public Function Reboot(Optional ByVal Force As Boolean = False)

    'si on est sous NT, on rcupre le privilge
    If IsPrivilegeNecessary Then Call EnableShutDown

    If Force Then
        ShutDown = ExitWindowsEx(EWX_FORCE Or EWX_REBOOT, 0)
    Else
        ShutDown = ExitWindowsEx(EWX_REBOOT, 0)
    End If
End Function


'---------------------------------------------------------------------------------------
' Procedure : LogOff
' DateTime  : 29/08/2007 19h00
' Author    : Vb System Library
' Purpose   : Dlogue de l'ordinateur
' Params    : Force : forcer ou non l'action
'---------------------------------------------------------------------------------------
Public Function LogOff(Optional ByVal Force As Boolean = False)
    If Force Then
        ShutDown = ExitWindowsEx(EWX_FORCE Or EWX_LOGOFF, 0)
    Else
        ShutDown = ExitWindowsEx(EWX_LOGOFF, 0)
    End If
End Function


'---------------------------------------------------------------------------------------
' Procedure : GetTotalCpuUsage
' DateTime  : 29/08/2007 19h00
' Author    : Vb System Library
' Purpose   : Rcupre le pourcentage d'utilisation du CPU
'---------------------------------------------------------------------------------------
Public Function GetTotalCpuUsage() As Double
Dim SysBaseInfo As SYSTEM_BASIC_INFORMATION
Dim SysPerfInfo As SYSTEM_PERFORMANCE_INFORMATION
Dim SysTimeInfo As SYSTEM_TIME_INFORMATION
Dim dbIdleTime As Currency
Dim dbSystemTime As Currency

    'renseigne sur le nombre de processEURs
    Call NtQuerySystemInformation(SYSTEM_BASICINFORMATION, VarPtr(SysBaseInfo), LenB(SysBaseInfo), 0&)

    'nouveau temps systme
    Call NtQuerySystemInformation(SYSTEM_TIMEINFORMATION, VarPtr(SysTimeInfo), LenB(SysTimeInfo), 0&)

    'nouveau temps idle
    Call NtQuerySystemInformation(SYSTEM_PERFORMANCEINFORMATION, VarPtr(SysPerfInfo), LenB(SysPerfInfo), 0&)

    'valeur actuelle = nouvelle valeur - ancienne valeur
    dbIdleTime = SysPerfInfo.liIdleTime - liOldIdleTime
    dbSystemTime = SysTimeInfo.liKeSystemTime - liOldSystemTime
    
    If dbSystemTime <> 0 Then dbIdleTime = dbIdleTime / dbSystemTime
    
    dbIdleTime = 100 - dbIdleTime * 100 / SysBaseInfo.bKeNumberProcessors
    If dbIdleTime > 0 Then GetTotalCpuUsage = dbIdleTime
    
    liOldIdleTime = SysPerfInfo.liIdleTime
    liOldSystemTime = SysTimeInfo.liKeSystemTime
    
End Function


'---------------------------------------------------------------------------------------
' Procedure : GetGlobalMemoryInfo
' DateTime  : 29/08/2007 19h00
' Author    : Vb System Library
' Purpose   : Rcupre les informations globales sur la mmoire du systme
'---------------------------------------------------------------------------------------
Public Function GetGlobalMemoryInfo() As GLOBAL_MEMORY_INFO
Dim mStat As MEMORYSTATUSEX

    mStat.dwLength = Len(mStat)
    'rcupre les infos
    Call GlobalMemoryStatusEx(mStat)
    
    With GetGlobalMemoryInfo
        .AvailablePageFile = mStat.ullAvailPageFile * 10000
        .AvailablePhysicalMemory = mStat.ullAvailPhys * 10000
        .AvailableVirtualMemory = mStat.ullAvailVirtual * 10000
        .TotalPageFile = mStat.ullTotalPageFile * 10000
        .TotalPhysicalMemory = mStat.ullTotalPhys * 10000
        .UsedPhysicalMemory = (mStat.ullTotalPhys - mStat.ullAvailPhys)
        .UsedPhysicalMemory = .UsedPhysicalMemory * 10000
        .TotalVirtualMemory = mStat.ullTotalVirtual * 10000
    End With

End Function


'---------------------------------------------------------------------------------------
' Procedure : GetTimeSinceWindowsStart
' DateTime  : 29/08/2007 19h00
' Author    : Vb System Library
' Purpose   : Rcupre le temps depuis le dmarrage de Windows
'---------------------------------------------------------------------------------------
Public Function GetTimeSinceWindowsStart() As Long
    GetTimeSinceWindowsStart = timeGetTime
End Function


'---------------------------------------------------------------------------------------
' Procedure : GetComputerName
' DateTime  : 05/09/2007 13h00
' Author    : Vb System Library
' Purpose   : Rcupre le nom du PC
'---------------------------------------------------------------------------------------
Public Function GetComputerName() As String
Dim Buffer As String
    Buffer = String$(32, vbNullChar)    '32 = MAX_SIZE +1
    Call GetComputerNameAPI(Buffer, 32)
    GetComputerName = Left$(Buffer, InStr(Buffer, vbNullChar) - 1)
End Function


'---------------------------------------------------------------------------------------
' Procedure : GetSystemMetricsValue
' DateTime  : 05/09/2007 13h00
' Author    : Vb System Library
' Purpose   : Rcupre les informations 'metrics'
'---------------------------------------------------------------------------------------
Public Function GetSystemMetricsValue(ByVal MetricsType As SYSTEM_METRICS_CONSTANTS) As Long
Dim pData As APPBARDATA
    If MetricsType = SM_APPBARHEIGHT Then
        'rcupre la hauteur de la barre de tache
        Call SHAppBarMessage(ABM_GETTASKBARPOS, pData)
        GetSystemMetricsValue = Screen.TwipsPerPixelY * (pData.rc.Bottom - pData.rc.Top)
    Else
        GetSystemMetricsValue = GetSystemMetrics(MetricsType)
    End If
End Function




Private Sub Initialize()
'initialise la classe ; sauvegarde les temps initiaux
Dim SysTimeInfo As SYSTEM_TIME_INFORMATION
Dim SysPerfInfo As SYSTEM_PERFORMANCE_INFORMATION

    'obtient le temps system
    Call NtQuerySystemInformation(SYSTEM_TIMEINFORMATION, VarPtr(SysTimeInfo), LenB(SysTimeInfo), 0&)

    'obtient le nouveau temps idle
    Call NtQuerySystemInformation(SYSTEM_PERFORMANCEINFORMATION, VarPtr(SysPerfInfo), LenB(SysPerfInfo), 0&)

    liOldIdleTime = SysPerfInfo.liIdleTime
    liOldSystemTime = SysTimeInfo.liKeSystemTime
End Sub


' Donne le privilge ncessaire
Private Sub EnableShutDown()
Dim hProc As Long
Dim mLUID As LUID
Dim hToken As Long
Dim mNewPriv As TOKEN_PRIVILEGES
Dim mPriv As TOKEN_PRIVILEGES

    hProc = GetCurrentProcess()
    
    Call OpenProcessToken(hProc, TOKEN_ADJUST_PRIVILEGES + TOKEN_QUERY, hToken)
    Call LookupPrivilegeValue(vbNullString, "SeShutdownPrivilege", mLUID)
    
    With mPriv
        .PrivilegeCount = 1
        .Privileges.Attributes = SE_PRIVILEGE_ENABLED
        .Privileges.pLuid = mLUID
    End With
    
    Call AdjustTokenPrivileges(hToken, False, mPriv, 4 + (12 * mPriv.PrivilegeCount), mNewPriv, 4 + (12 * mNewPriv.PrivilegeCount))
    Call CloseHandle(hProc)
End Sub


' Dtermine si la version de Windows ncessite un privilge
Private Function IsPrivilegeNecessary() As Boolean
Dim tOS As OSVERSIONINFO
    tOS.dwOSVersionInfoSize = Len(tOS)
    Call GetVersionEx(tOS)
    IsPrivilegeNecessary = (tOS.dwPlatformId = 2)
End Function
