VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "PhysicalDisk"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'---------------------------------------------------------------------------------------
' Module    : PhysicalDisk
' DateTime  : 30/04/2007 23:25
' Author    : Vb System Library
' Purpose   : Objet Disque physique
' Copyright : (C) 2007 L'quipe Vb System Library
'              See "modPresentation" for more information
'---------------------------------------------------------------------------------------
' Librairie de fonctions permettant d'agir simplement et rapidement sur le systme.
' Copyright (C) 2007 - L'quipe Vb System Library
' This library is free software; you can redistribute it and/or
' modify it under the terms of the GNU Lesser General Public
' License as published by the Free Software Foundation; either
' version 2.1 of the License, or (at your option) any later version.
' This library is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
' Lesser General Public License for more details.
' You should have received a copy of the GNU Lesser General Public
' License along with this library; if not, write to the Free Software
' Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
'---------------------------------------------------------------------------------------

' =======================================================
'
' Classe originale tire du programme Hex Editor VB
' de violent_ken (Alain Descotes)
'
' =======================================================


Option Explicit


Private clsFile As clsFileSystem
Private MyDisk As ClassDisk


'=======================================================
'variables de la structure clsDriveInfo
'=======================================================
Private Type ClassDisk
    Cylinders As Currency
    MediaType As MediaType
    TracksPerCylinder As Long
    SectorsPerTrack As Long
    TotalSpace As Currency
    BytesPerSector As Long
    TotalPhysicalSectors As Currency
    strMediaType As String
    DiskName As String
    DiskNumber As Byte
End Type

'=======================================================
'Dfinit le path de cet objet
'=======================================================
Friend Function SetDiskNumber(DiskNumber As Byte, Optional ByVal RefreshInformations As Boolean = True)
    'on dfinit le path du fichier
    MyDisk.DiskNumber = DiskNumber
    If RefreshInformations Then Call RefreshInfos
End Function

'=======================================================
'//Proprits de l'objet
'=======================================================
Public Property Get Cylinders() As Currency: Cylinders = MyDisk.Cylinders: End Property
Public Property Get MediaType() As MediaType: MediaType = MyDisk.MediaType: End Property
Public Property Get TracksPerCylinder() As Long: TracksPerCylinder = MyDisk.TracksPerCylinder: End Property
Public Property Get SectorsPerTrack() As Long: SectorsPerTrack = MyDisk.SectorsPerTrack: End Property
Public Property Get TotalSpace() As Currency: TotalSpace = MyDisk.TotalSpace: End Property
Public Property Get BytesPerSector() As Long: BytesPerSector = MyDisk.BytesPerSector: End Property
Public Property Get TotalPhysicalSectors() As Currency: TotalPhysicalSectors = MyDisk.TotalPhysicalSectors: End Property
Public Property Get strMediaType() As String: strMediaType = MyDisk.strMediaType: End Property
Public Property Get DiskNumber() As Byte: DiskNumber = MyDisk.DiskNumber: End Property
Attribute DiskNumber.VB_UserMemId = 0
Public Property Get DiskName() As String: DiskName = Trim$(MyDisk.DiskName): End Property



'=======================================================
'//Mthodes
'=======================================================

'=======================================================
'Rafraichit les infos
'=======================================================
Public Sub RefreshInfos()
Dim tGeom As DiskGeometry
Dim hDrive As Long
    
    'rcupre un handle valide sur ce drive physique
    hDrive = CreateFile("\\.\PHYSICALDRIVE" & CStr(Me.DiskNumber), GENERIC_READ Or _
        GENERIC_WRITE, FILE_SHARE_READ Or FILE_SHARE_WRITE, 0&, OPEN_EXISTING, 0, 0)

    'rcupre la gomtrie du disque
    tGeom = clsFile.GetPhysicalDiskGeometry_HANDLE(hDrive)

    'rcupre le nom du disque
    MyDisk.DiskName = clsFile.GetPhysicalDiskName_HANDLE(hDrive, Me.DiskNumber)
    
    'referme le handle
    Call CloseHandle(hDrive)
    
    With MyDisk
        .BytesPerSector = tGeom.BytesPerSector
        .Cylinders = tGeom.Cylinders
        .MediaType = tGeom.MediaType
        .SectorsPerTrack = tGeom.SectorsPerTrack
        .TracksPerCylinder = tGeom.TracksPerCylinder
        .strMediaType = tGeom.strMediaType
    
        'calculs diverses
        .TotalSpace = CCur(.SectorsPerTrack * .TracksPerCylinder * _
            .Cylinders * .BytesPerSector)
        .TotalPhysicalSectors = CCur(.SectorsPerTrack * _
            .TracksPerCylinder * .Cylinders)
    End With
   
End Sub

'=======================================================
'Lecture dans le disque
'=======================================================
Public Function ReadPhysicalDiskString(ByVal StartingSector As Currency, ByVal _
    nBytes As Long) As String
    
Dim bpsec As Long

    'dtermine le nombre de bytes par secteur
    If Me.BytesPerSector = 0 Then bpsec = _
        clsFile.GetPhysicalDiskGeometry(Me.DiskNumber).BytesPerSector Else _
        bpsec = Me.BytesPerSector
    
    ReadPhysicalDiskString = clsFile.ReadPhysicalDiskString(Me.DiskNumber, StartingSector, _
        nBytes, bpsec)

End Function

'=======================================================
'Ecriture dans le disque
'=======================================================
Public Function WritePhysicalDiskString(ByVal StartingSector As Currency, ByVal _
    nBytes As Long, ByVal StringToWrite As String) As Long
    
Dim bpsec As Long

    'dtermine le nombre de bytes par secteur
    If Me.BytesPerSector = 0 Then bpsec = _
        clsFile.GetPhysicalDiskGeometry(Me.DiskNumber).BytesPerSector Else _
        bpsec = Me.BytesPerSector
    
    WritePhysicalDiskString = clsFile.WritePhysicalDiskString(Me.DiskNumber, _
        StartingSector, nBytes, bpsec, StringToWrite)
    
End Function

'=======================================================
'Lance la sanitization... my god...
'=======================================================
Public Function Sanitize() As Long
    Sanitize = clsFile.SanitizePhysicalDisk(Me.DiskNumber)
End Function

'=======================================================
'Renvoie True si le disk est disponible
'=======================================================
Public Function IsDiskAvailable() As Boolean
    IsDiskAvailable = clsFile.IsPhysicalDiskAvailable(Me.DiskNumber)
End Function






'=======================================================
'Subs de la classe
'=======================================================
Private Sub Class_Initialize()
    'instancie la classe clsFile
    Set clsFile = New clsFileSystem
End Sub

Private Sub Class_Terminate()
    'libre la classe clsFile
    Set clsFile = Nothing
End Sub


