VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Processes"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'---------------------------------------------------------------------------------------
' Module    : Processes
' DateTime  : 30/04/2007 23:26
' Author    : Vb System Library
' Purpose   : Collection de processus
' Copyright : (C) 2007 L'quipe Vb System Library
'              See "modPresentation" for more information
'---------------------------------------------------------------------------------------
' Librairie de fonctions permettant d'agir simplement et rapidement sur le systme.
' Copyright (C) 2007 - L'quipe Vb System Library
' This library is free software; you can redistribute it and/or
' modify it under the terms of the GNU Lesser General Public
' License as published by the Free Software Foundation; either
' version 2.1 of the License, or (at your option) any later version.
' This library is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
' Lesser General Public License for more details.
' You should have received a copy of the GNU Lesser General Public
' License along with this library; if not, write to the Free Software
' Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
'---------------------------------------------------------------------------------------


'---------------------------------------------------------------------------------------
'
' Proprits
'   Window
'   Count
'
' Mthodes
'   RefreshList
'   RefreshItemInfos
'
'---------------------------------------------------------------------------------------

Option Explicit


' Les Processus (de 1  nbProcesses)
Private colProcesses()  As Process
Private nbProcesses     As Long

Private clsProcess      As clsProcesses


Private Sub Class_Initialize()
    Set clsProcess = New clsProcesses
    ReDim colProcesses(1 To 1) As Process
    nbProcesses = 0
End Sub

Private Sub Class_Terminate()
    Dim t As Long
    ' Vide le tableau de processes
    For t = 1 To nbProcesses
        Set colProcesses(t) = Nothing
    Next t
    Erase colProcesses
    Set clsProcess = Nothing
End Sub


'---------------------------------------------------------------------------------------
' Les proprits
'---------------------------------------------------------------------------------------


' Renvoie un item de la liste
Public Property Get Process(ByVal Index As Long) As Process
    Set Process = colProcesses(Index)
End Property


' Le nombre de processus
Public Property Get Count() As Long
    Count = nbProcesses
End Property


'---------------------------------------------------------------------------------------
' Procedure : RefreshItemInfos
' DateTime  : 09/03/2007 22:36
' Author    : Vb System Library
' Purpose   : Rafraichit toutes les informations d'un item de la liste
' Params    :
'---------------------------------------------------------------------------------------
Public Sub RefreshItemInfos()
    Dim t As Long
    For t = 1 To nbProcesses
        colProcesses(t).RefreshInfos
    Next
End Sub


'---------------------------------------------------------------------------------------
' Procedure : RefreshList
' DateTime  : 30/11/2006 17:19
' Author    : Vb System Library
' Purpose   : Rafraichit la liste des processus
' Params    :   [Optionnel] RefreshItemInfos : Si activ, les informations des processus seront rafraichies
'                                               Sinon elles ne seront PAS rafraichies (PAR DEFAUT)
'               Les parametres suivants dfinissent le filtre de la liste :
'               [Optionnel] ID : ID du processus
'               [Optionnel] Name : Nom des processus
'               [Optionnel] ParentProcessID : ID du processus parent
'---------------------------------------------------------------------------------------
Public Sub RefreshList(Optional ByVal RefreshItemInfos As Boolean = False, Optional ByVal ID As Long = -1, Optional ByVal Name As String = "", Optional ByVal ParentProcessID As Long = -1)

    Dim tabProcessID()      As Long
    Dim tempProcess         As Process
    Dim i                   As Long
    Dim Valide              As Boolean
    Dim Count               As Long

    ' Vide la liste
    For i = 1 To nbProcesses
        Set colProcesses(i) = Nothing
    Next i
    nbProcesses = 0
    Erase colProcesses

    ' Dresse la liste des process
    clsProcess.GetProcessIDList tabProcessID()
    Count = 0

    For i = LBound(tabProcessID) To UBound(tabProcessID)
        ' Cre l'objet processus
        Set tempProcess = New Process
        tempProcess.GetProcessByID tabProcessID(i), RefreshItemInfos
        ' Si le processus rpond aux critres
        Valide = True
        If (ID <> -1) And (tempProcess.ID <> ID) Then Valide = False
        If (Name <> "") And (tempProcess.Name <> Name) Then Valide = False
        If (ParentProcessID <> -1) And (tempProcess.ParentProcessID <> ParentProcessID) Then Valide = False
        ' Ajoute le processus
        If Valide = True Then
            ' Redimensionne
            Count = Count + 1
            ReDim Preserve colProcesses(1 To Count) As Process
            Set colProcesses(Count) = tempProcess
        End If
        Set tempProcess = Nothing
    Next i
    
    ' Le nombre d'lments du tableau
    nbProcesses = Count

    Erase tabProcessID

End Sub
