VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "VirtualScreen"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'---------------------------------------------------------------------------------------
' Module    : VirtualScreen
' DateTime  : 30/04/2007 23:27
' Author    : Vb System Library
' Purpose   : Objet Ecran virtuel
' Copyright : (C) 2007 L'quipe Vb System Library
'              See "modPresentation" for more information
'---------------------------------------------------------------------------------------
' Librairie de fonctions permettant d'agir simplement et rapidement sur le systme.
' Copyright (C) 2007 - L'quipe Vb System Library
' This library is free software; you can redistribute it and/or
' modify it under the terms of the GNU Lesser General Public
' License as published by the Free Software Foundation; either
' version 2.1 of the License, or (at your option) any later version.
' This library is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
' Lesser General Public License for more details.
' You should have received a copy of the GNU Lesser General Public
' License along with this library; if not, write to the Free Software
' Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
'---------------------------------------------------------------------------------------

Option Explicit


' La collection de Monitor
Private colMonitors As Collection

Private cScreens As clsScreens


Private Sub Class_Initialize()
    Set colMonitors = New Collection
End Sub

Private Sub Class_Terminate()
    Set colMonitors = Nothing
End Sub


'---------------------------------------------------------------------------------------
' Les mthodes
'---------------------------------------------------------------------------------------


' Rafraichit la liste des crans
Public Sub RefreshMonitorList()
    Me.Clear
    RefreshListMonitor Me
End Sub


' Fonctions inaccessibles  l'utilisateur
' Ajoute un moniteur
Friend Sub Add(hMonitor As Long)
    Dim Mon As Monitor
    Set Mon = New Monitor
    Mon.GetMonitorByHandle hMonitor
    colMonitors.Add Mon
    Set Mon = Nothing
End Sub
' Vide la collection
Friend Sub Clear()
    Dim t As Long
    If colMonitors.Count > 0 Then
        For t = 1 To colMonitors.Count
            Set colMonitors.Item(t) = Nothing
            colMonitors.Remove 1
        Next t
    End If
End Sub


'---------------------------------------------------------------------------------------
' Les proprits
'---------------------------------------------------------------------------------------

' Rcuprer un cran
Public Property Get Monitor(ByVal Index As Long) As Monitor
    Set Monitor = colMonitors(Index)
End Property

' Le nombre d'crans
Public Property Get MonitorCount() As Long
    MonitorCount = colMonitors.Count
End Property


' Dimensions de l'cran virtuel
Public Property Get Left() As Long
    Left = cScreens.GetVirtualScreenLeft
End Property
Public Property Get Top() As Long
    Top = cScreens.GetVirtualScreenTop
End Property
Public Property Get Width() As Long
    Width = cScreens.GetVirtualScreenWidth
End Property
Public Property Get Height() As Long
    Height = cScreens.GetVirtualScreenHeight
End Property
